#!/bin/sh

ALLBINS="start_pvm stop_pvm spmd master slave"

if [ "$CODINE_ROOT" = "" ]; then
   echo please set your \$CODINE_ROOT enviroment variable before calling this script
   exit 1 
fi

if [ ! -f $CODINE_ROOT/util/arch_variables ]; then
   echo file \"$CODINE_ROOT/util/arch_variables\" does not exist
   exit 1
fi

. $CODINE_ROOT/util/arch_variables

if [ $# -gt 0 ]; then
   ARCHS="$*"
else
   ARCHS="`echo *`"
fi

clear

$ECHO
$ECHO "        Installation of start_pvm and stop_pvm for CODINE/GRD PE"
$ECHO "        --------------------------------------------------------"
$ECHO
$ECHO "This script should be called from the directory"
$ECHO
$ECHO "   \$CODINE_ROOT/pvm/src"
$ECHO
$ECHO "It will check if the architecture subdirectory exists and copy"
$ECHO "the binaries"
$ECHO
$ECHO "   \"start_pvm\""
$ECHO "   \"stop_pvm\""
$ECHO
$ECHO "job sample binaries"
$ECHO
$ECHO "   \"spmd\""
$ECHO "   \"master\""
$ECHO "   \"slave\""
$ECHO
$ECHO "to"
$ECHO
$ECHO "   \$CODINE_ROOT/pvm/bin/<architecture>"
$ECHO
$ECHO "If you are using the templates" 
$ECHO 
$ECHO "   \$CODINE_ROOT/pvm/start_pvm.sh"
$ECHO "   \$CODINE_ROOT/pvm/stop_pvm.sh"
$ECHO 
$ECHO "for starting and stopping PVM (defined as \"start_proc_args\""
$ECHO "and \"stop_proc_args\" in the definition of your parallel"
$ECHO "environments), this will be the right location for the installation."
$ECHO
$ECHO "Do you want beginn with the installation (Y/N) [Y] \c"

read INP
if [ "$INP" = "" -o "$INP" = y -o "$INP" = Y ]; then
   :
else
   $ECHO No installation
   exit 1
fi

for i in *; do
   if [ -d $i ]; then
      $ECHO "checking for architecture subdirectory: $i ..."
      $ECHO "   Checking for $ALLBINS ... \c"
      found=true
      for b in $ALLBINS; do   
         if [ ! -f $i/$b ]; then
            found=false
         fi
      done

      if [ $found = true ]; then
         $ECHO "found:"
         $ECHO "      Installing in ../bin/$i ... \c"   

         mkdir -p ../bin/$i
         for b in $ALLBINS; do   
            cp $i/$b ../bin/$i
            chmod 755 ../bin/$i/$b
         done
         
         $ECHO "done"
      else
         $ECHO "not found"
      fi
   fi
done
