#!/bin/sh
#
# (c) 2000, 2001 Sun Microsystems, Inc.
#

#
# example for a load sensor script
# 
# returns the number of logged in users as load value "nuser"
#
# Do not forget to add the "nuser" complex value to to your "host" complex
# and to add a load or suspend threshold to your queues.
#
# The line in the host complex should be defined as follows ("shortcut" and
# "requestable" can be defined differently)
#
# name  shortcut   type   value    relop requestable consumable default
# nuser nuser      INT    0        >=    NO          NO         0
#
#
# Be careful: Load sensor scripts are started with root permissions.
# In an admin_user system euid=0 and uid=admin_user
#

PATH=/bin:/usr/bin

ARCH=`$CODINE_ROOT/util/arch`
HOST=`$CODINE_ROOT/utilbin/$ARCH/gethostname -name`

ls_log_file=/tmp/ls.dbg

# uncomment this to log load sensor startup  
# echo `date`:$$:I:load sensor `basename $0` started >> $ls_log_file

end=false
while [ $end = false ]; do

   # ---------------------------------------- 
   # wait for an input
   #
   read input
   result=$?
   if [ $result != 0 ]; then
      end=true
      break
   fi
   
   if [ "$input" = "quit" ]; then
      end=true
      break
   fi

   # ---------------------------------------- 
   # send mark for begin of load report
   echo "begin"

   # ---------------------------------------- 
   # send load value arch
   #
   echo "$HOST:nuser:`who | cut -f1 -d" " | sort | uniq |wc -l`"

   # ---------------------------------------- 
   # send mark for end of load report
   echo "end"
done

# uncomment this to log load sensor shutdown  
# echo `date`:$$:I:load sensor `basename $0` exiting >> $ls_log_file
