#!/bin/sh
#
# (c) 2000, 2001 Sun Microsystems, Inc.
#
# usage: shutdown_commd.sh -all|host...
#
# Shutdown commd's on all hosts (-all) or hosts given as argument.
#
# Started without argument "-all" shutdown commd's on all given hosts 
# Started with the "-all" argument shutdown all commd
# found in the qmaster spool directory exec host list

# - requires the variable CODINE_ROOT and if other than default COD_CELL and
#  COMMD_PORT (if the service codine_commd/tcp is not used) to be set
# - uses the command "codcommdcntl" for the default binary location
# - must by called by a user who has permissions to start "codcommdcntl" 

if [ $# = 1 -a "$1" = "-all" ]; then
   if [ "$COD_CELL" = "" ]; then
      COD_CELL=default
   fi
   qma_spool_dir=`grep qmaster_spool_dir $CODINE_ROOT/$COD_CELL/common/configuration | \
        awk '{ print $2 }'`
   targets="`ls $qma_spool_dir/exec_hosts|egrep -v template`"
else
   targets=$*
fi

ARCH=`$CODINE_ROOT/util/arch`

for h in $targets; do
   echo shutting down commd at host $h
   $CODINE_ROOT/bin/$ARCH/codcommdcntl -k -host $h
done
